#ifndef __CHKSUM__
#define __CHKSUM__

#include "Packet.h"


#define HI(VALUE)		(VALUE >> 16)
#define LOW(VALUE)		(VALUE & 0xFFFF)
#define SUM(VALUE)		(HI(VALUE) + LOW(VALUE))


UINT __IPSum__;
UINT __TCPSum__;


/**************************************************
 * עͣChecksum
 **************************************************/

#define MAX_WORD_LEN				\
	((sizeof(HEADER_TCP) + sizeof(HEADER_PSD) + sizeof(HEADER_TCP_OPTS)) / sizeof(USHORT))

#define MAX_TBL_SIZE				\
	(0x10000 * MAX_WORD_LEN)

USHORT TableChkSum[MAX_TBL_SIZE];

/**************************************************
 * InitChkSumTable
 * עͣʼChecksumӳ
 *       : ֶκ(sum) -> У(checksum)
 **************************************************/
VOID InitChkSumTable()
{
	UINT i;
	UINT chkSum;

	for(i=0; i<MAX_TBL_SIZE; i++)
	{
		chkSum = SUM(i);
		chkSum += HI(chkSum);
		TableChkSum[i] = (USHORT)~chkSum;
	}
}

/**************************************************
 * GetIPSum
 * עͣIPֶκ
 **************************************************/
VOID InitIPSum(USHORT buf[])
{
	__IPSum__ =
		buf[0] +	//VerLen & TOS
		buf[1] +	//Length
		buf[3] +	//Flags & Frag
		buf[8] +	//DstIP-Hi
		buf[9];		//DstIP-Low
}

/**************************************************
 * GetTCPSum
 * עͣTCPֶκ
 **************************************************/
VOID InitTCPSum(USHORT buf[], ULONG DstIP)
{
	__TCPSum__ =
		/* TCPαͷ */
		SUM(DstIP) +
		HTONS(PROTO_IP_TCP) +
		HTONS(sizeof(HEADER_TCP) + sizeof(HEADER_TCP_OPTS)) +

		buf[1] +	//DstPort
		buf[6] +	//Length & Flags
		buf[7] +	//WinSize
		buf[9] +	//UrgPtr
		buf[10] + buf[11] + buf[12] + buf[13]; // TCP Options
}

#define IPChecksum(SrcIP, Ident, TTLProt)			\
	TableChkSum[__IPSum__ + SUM(SrcIP) + Ident + TTLProt]

#define TCPChecksum(SrcIP, SrcPort, Seq)			\
	TableChkSum[__TCPSum__ + SUM(SrcIP) + SUM(Seq) + SrcPort]

#endif