#ifndef __PACKET__
#define __PACKET__


#ifndef BYTE
typedef UCHAR BYTE;
#endif


typedef BYTE ADDR_MAC[6];

/*
 * Ethernetṹ
 */
typedef struct
{
	ADDR_MAC	DstMAC;
	ADDR_MAC	SrcMAC;
	USHORT		Type;
} HEADER_ETHER;


/*
 * IPṹ
 */
typedef struct
{
	BYTE		VerLen;
	BYTE		TOS;
	USHORT		Length;
	USHORT		Ident;
	USHORT		Flags;
	USHORT		TTLProto;
	USHORT		ChkSum;
	ULONG		SrcIP;
	ULONG		DstIP;
} HEADER_IP;


/*
 * TCPṹ
 */
typedef struct
{
	USHORT		SrcPort;
	USHORT		DstPort;
	ULONG		Seq;
	ULONG		Ack;
	BYTE		HeaderLen;
	BYTE		Flags;
	USHORT		WinSize;
	USHORT		ChkSum;
	USHORT		UrgPtr;
} HEADER_TCP;

/*
 * TCPѡ
 */
typedef struct
{
	USHORT		KindLen1;
	USHORT		MSS;		/*MaxSegSize*/
	USHORT		KindLen2;
	USHORT		Value;
} HEADER_TCP_OPTS;

/*
 * TCPαͷ
 */
typedef struct
{ 
	ULONG		SrcIP;
	ULONG		DstIP;
	BYTE		MBZ;
	BYTE		Proto;
	USHORT		TCPLen;
} HEADER_PSD;



typedef struct
{
	USHORT			Padding;

	HEADER_ETHER	Ether;		//size:14 (ڲ)
	HEADER_IP		IP;			//size:20 ()
	HEADER_TCP		TCP;		//size:8  ()
	HEADER_TCP_OPTS	Opts;
} PACKET_SYN;

#define SIZE_PKT_SYN	(sizeof(PACKET_SYN) - sizeof(USHORT))


/**************************************************
 * ꣺HTONS
 * עֽͣ˳ת
 **************************************************/
#define HTONS(_host)						\
(											\
	(((_host) & 0xff00) >> 8) |				\
	(((_host) & 0x00ff) << 8)				\
)

/*
 * Э
 */
#define PROTO_IP		0x0008
#define PROTO_IP_TCP	6

#define FLAG_TCP_SYN	2


#endif